PrefabFiles = {
}

Assets = {
}

TIME = GetModConfigData("TIME")
AMPLITUDE = GetModConfigData("AMPLITUDE")

local function onEntityAttacked(inst, data)
	local dt = 0.02
	local n = 0
	local maxcount = TIME / dt
	local oldmove = 0
	local hitshaketask = nil
	hitshaketask = inst:DoPeriodicTask(dt, function(inst)
		local diff
		n = n + 1
		local newmove = math.sin(math.pi * n * dt / TIME) * AMPLITUDE
		if n % 2 == 0 then
			newmove = -newmove
		end
		if n >= maxcount then
			newmove = 0
		end
		
		diff = newmove - oldmove
		
		local pos = inst:GetPosition()
		pos.x = pos.x + diff
		inst.Transform:SetPosition(pos:Get())
		
		if n >= maxcount then
			hitshaketask:Cancel()
		end
	end)
end

AddPrefabPostInitAny(function(inst)
	if inst.components.combat then
		inst:ListenForEvent("attacked", onEntityAttacked)
	end
end)
